/**
 * Sales Archiving Web Service
 * -----------------------
 *
 * This piece of software is part of the Sales Archiving Web Service example.
 *
 * Simply speaking, the aim of this software is to deploy, on JOnAS 4, a web
 * service to which sales data can be sent. That service would then store all
 * received data in a database using EJB3s.
 *
 *
 * If this software works, it has been written by Savas Ali TOKMEN, who has a
 * web site on the http://ali.tokmen.com/ address. If it doesn't work and
 * you're experiencing problems with it, I don't know who wrote it.
 *
 * Created the 31st of March 2007
 */
package SalesArchivingService;

import java.rmi.RemoteException;

import javax.naming.*;

/**
 * This is the implementation of the Sales Archiving Web Service. It will call
 * the Sales Archiving Bean in order to save the received datum.
 */
public class SalesArchivingServiceImpl implements SalesArchivingServiceInterface {
	public void sendSalesData(SalesItem item, SalesData[] datum) throws RemoteException {
		try {
			Context ctx = new InitialContext();
/*			// DEBUG - enumerate all registered services
			NamingEnumeration list = ctx.list("");
			while (list.hasMore()) {
				NameClassPair nc = (NameClassPair)list.next();
				System.out.println(nc);
			}
*/			SalesArchivingBeanRemote containerBean = (SalesArchivingBeanRemote) ctx.lookup("SalesArchivingService.SalesArchivingBean_SalesArchivingService.SalesArchivingBeanRemote@Remote");
			containerBean.saveSalesData(item, datum);
		} catch(Exception e) {
			throw new RemoteException("Error saving sales data: "+e);
		}
	}
}
